# Quantum Enhanced Selection

This programs are inspired by
 [MBC](https://ieeexplore.ieee.org/abstract/document/4358783/metrics#metrics),
 which proposed a quantum selection subroutine more efficient than the classical version in terms of oracle calls.
 
 The quantum selection subroutine is based on the quantum searching procedures [BBHT](https://arxiv.org/abs/quant-ph/9605034)
 and [DH](https://arxiv.org/abs/quant-ph/9607014), which employ the principles of Grover algorithm.
 These algorithms can be interpreted as amplitude amplification algorithms.
 
 For the algorithm MBC a comparative oracle is used, to obtain a conditional amplification of the states.
 The comparative oracle takes a searching register and a threshold register.
 The operation it performs produces the algorithm to amplify the states in the searching register that are higher than the threshold one.
 In this programs we tested the behavior of these algorithms when many threshold values are used in a superposed state.
 
 We used two types of thresholds intended to be used in the amplification algorithm:
 
 - **Single threshold:** Uses a single value in the state of the threshold register.
 
 - **Multiple threshold:** Uses many states in the threshold registers.
 The amplitude of each state is obtained from a state that has been amplified with a single threshold.
  
 The file [ComparativeAmplification]() implements the fundamental functions simulating the quantum operations.
 In the Jupyter Notebook [AA_compared_oracle]() many examples are tested with different fitness functions for the multiple threshold amplitude amplification.
 In the Jupyter Notebook [Comparing_AA_methods]() both amplitude amplification methods were compared as optimization algorithms.
 To run this Jupyter Notebooks they have to moved to the main directory.
 
 The Notebook [upgrade_probability]() was used to compute the analytical expression for the probability to find a higher than threshold state, thus getting an upgrade.
 
 The [data]() directory contains the output files generated from the comparision between the threshold methods as function optimisers. 