import numpy as np
import matplotlib.pyplot as plt

def show_finalstate(ab, row_label, col_label, figurelabel):
    # definitions for the axes
    left, width = 0.1, 0.65
    bottom, height = 0.1, 0.65
    spacing = 0.005

    rect_scatter = [left, bottom, width, height]
    rect_histx = [left, bottom + height + spacing, width, 0.2]
    rect_histy = [left + width + spacing, bottom, 0.2, height]

    # start with a rectangular Figure
    plt.figure(figsize=(6, 6))

    ax_scatter = plt.axes(rect_scatter)
    ax_scatter.tick_params(direction='in', top=True, right=True)
    ax_histx = plt.axes(rect_histx)
    ax_histx.tick_params(direction='in', labelbottom=False)
    ax_histy = plt.axes(rect_histy)
    ax_histy.tick_params(direction='in', labelleft=False)

    # the PROBABILITY MATRIX ELEMENTS plot:
    N, M = ab.shape
    im = ax_scatter.imshow(ab*ab)
    if N <=32:
        for i in range(N):
            for j in range(N):
                text = ax_scatter.text(j, i, int((ab*ab)[i, j]*N*N),
                               ha="center", va="center", color="w")
    #cbar = ax_scatter.figure.colorbar(im, ax=ax_scatter,
    #                                  orientation='horizontal') #, **cbar_kw)
    #cbar.ax.set_xlabel(cbarlabel, rotation=0, va="center")

    # PROBABILITY DISTRIBUTIONS FOR NU VALUES AND I VALUES
    pb = sum(ab*ab)
    pa = sum((ab*ab).transpose())
    ax_histx.bar(range(N), pb)
    ax_histy.barh(range(N), pa)
    ax_histx.set_title(col_label)
    ax_histy.set_title(row_label)

    ax_histx.set_xlim(ax_scatter.get_xlim())
    ax_histy.set_ylim(ax_scatter.get_ylim())

    plt.show()